<?php
abstract class TreeBaseAction extends CAction
{
	private $_model;
	private $_modelName;
	
	public function __construct($controller,$id)
	{
		parent::__construct($controller,$id);
		if (!Yii::app()->getRequest()->getIsPostRequest() || !Yii::app()->getRequest()->getIsAjaxRequest()) {
			throw new CHttpException(400,'错误的请求方式');
		}
		$this->getModelName();
	}
	
	/**
	 * @return CActiveRecord
	 */
    public function loadModel()
	{
		if($this->_model===null)
		{
			if(Yii::app()->getRequest()->getParam('id'))
				$this->_model=$this->getModel()->node(Yii::app()->getRequest()->getParam('id'));
			if($this->_model===null)
				throw new CHttpException(404,'没有发现该记录');
		}
		return $this->_model;
	}
	
	/**
	 * @return CActiveRecord
	 */
	public function getModel() {
		return CActiveRecord::model($this->getModelName());
	}
	
	public function getModelName() {
		if ($this->_modelName===null) {
			$this->_modelName=Yii::app()->getRequest()->getParam('modelName');
			if ($this->_modelName===null) {
				throw new CHttpException(404,'必须传递modelName');
			}
		}
		return $this->_modelName;
	}
}